<script lang="ts">
  import { calculateColumn, findDuplicateDice } from '../helpers/grid'
  import type { ColumnT } from '../types'
  import Dice from './Dice.svelte'

  export let column: ColumnT
  export let onSelectColumn: (column: ColumnT) => void
  export let isPlayerTurn: boolean
  export let reverse: boolean

  $: total = calculateColumn(column)
  $: columnIsCompleted = column.every(b => Boolean(b.dice))
  $: dices = column.map(box => box.dice)
  $: duplicatedDice = findDuplicateDice(dices)
</script>

<div class="flex flex-col items-center gap-2 w-24" class:reverse-col={reverse}>
  <p class="font-semibold text-2xl">{total}</p>

  <div
    class="flex flex-col gap-2 w-full"
    class:reverse-col={reverse}
    class:cursor-pointer={isPlayerTurn && !columnIsCompleted}
    on:click|preventDefault={() => onSelectColumn(column)}
    on:keyup
  >
    {#each column as box}
      {#key `${box.column}-${box.dice || 'empty'}`}
        <div class="rounded bg-slate-800 grid place-content-center h-24 p-2 box-border">
          {#if Boolean(box.dice)}
            <Dice dice={box.dice} isDuplicated={duplicatedDice === box.dice} />
          {/if}
        </div>
      {/key}
    {/each}
  </div>

  <p class="font-semibold text-violet-500">{column[0].column}</p>
</div>

<style>
  .reverse-col {
    flex-direction: column-reverse;
  }
</style>
